package com.example.fuzzControll.controller.agentController;

import com.example.fuzzControll.domain.bo.AflnetDataParams;
import com.example.fuzzControll.domain.vo.AjaxResult;
import com.example.fuzzControll.service.AgentOfKittyService;
import jdk.internal.agent.resources.agent;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/agent")
@Slf4j
public class AgentController {
    @Autowired
    AgentOfKittyService agentOfKittyService;

    /**
     * 网络代理启动
     */
    //todo 启动有问题；代码待检查；给/etc/profile 加进入python虚拟环境
    @RequestMapping(value = "/kittyNetworkAgent", method = RequestMethod.GET)
    public AjaxResult startNetworkAgent(@RequestParam String networkCard, @RequestParam String monitorName) {
        try {
            Boolean flag = agentOfKittyService.startNetworkAgent(networkCard, monitorName);
            if (flag) {
                return AjaxResult.success("NetworkAgent run success!");
            } else {
                return AjaxResult.error("The agent failed to start!");
            }
        } catch (Exception e) {
            e.printStackTrace();
            return AjaxResult.error("The agent failed to start!");
        }
    }

    /**
     * ssh代理启动
     */
    //todo ssh使用存在问题我的理解是用来监控目标服务器的，通过ssh发送命令来监控
    @RequestMapping(value = "/kittySshAgent", method = RequestMethod.GET)
    public AjaxResult startSshAgent(@RequestParam String MonitorName, @RequestParam String SshUserName,
                                    @RequestParam String SshPassword, @RequestParam String SshIp,
                                    @RequestParam String SshPort, @RequestParam String Command) {
        try {
            new Thread(new Runnable() {
                @Override
                public void run() {
                    agentOfKittyService.startSshAgent(MonitorName, SshUserName, SshPassword, SshIp, SshPort, Command);
                }
            }).start();
            return AjaxResult.success("SshAgent run success!");
        } catch (Exception e) {
            e.printStackTrace();
            return AjaxResult.error("The agent failed to start!");
        }
    }

    /**
     * ssh网络代理的pcap文件下载接口
     */
    //todo ssh使用存在问题我的理解是用来监控目标服务器的，通过ssh发送命令来监控
    @RequestMapping(value = "/getAgentPcap", method = RequestMethod.GET)
    public byte[] getAgentPcap() {
        try {
            return agentOfKittyService.readPcapToByte();
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
}