package com.example.fuzzControll.service.impl;

import com.alibaba.fastjson2.JSON;
import com.example.fuzzControll.annotion.NeedCutBefore;
import com.example.fuzzControll.conf.AflnetProperties;
import com.example.fuzzControll.constents.CmdConstent;
import com.example.fuzzControll.domain.bo.FuzzParams;
import com.example.fuzzControll.exception.testException.AflnetException;
import com.example.fuzzControll.exception.testException.CmdException;
import com.example.fuzzControll.domain.bo.CmdStartParams;
import com.example.fuzzControll.service.AflnetPersistenceService;
import com.example.fuzzControll.service.FuzzParamsService;
import com.example.fuzzControll.service.TestService;
import com.example.fuzzControll.tools.system.GlobalClass;
import com.example.fuzzControll.tools.test.JsonUtils;
import com.example.fuzzControll.tools.test.TestCmdTools;
import com.example.fuzzControll.tools.test.TestControlTools;
import com.example.fuzzControll.tools.system.SystemRunningParams;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.concurrent.ConcurrentHashMap;

@Service("testService")
@Slf4j
public class TestServiceImpl implements TestService {

    @Autowired
    TestCmdTools cmdTools;
    @Autowired
    AflnetPersistenceService aflnetPersistenceService;

    @Autowired
    AflnetProperties aflnetProperties;
    @Autowired
    FuzzParamsService fuzzParamsService;

    //todo 不同服务不同端口
    @Override
    public void testStart(CmdStartParams cmdStartParams) throws AflnetException, CmdException {
        /*存入参数*/
        System.out.println(JSON.toJSONString(cmdStartParams));
        int missionId = GlobalClass.missionInfoMapper.selectTopMissionId() + 1;
        boolean flag = fuzzParamsService.saveFuzzParams(new FuzzParams(JSON.toJSONString(cmdStartParams), new Date(), missionId));
        if (!flag) {
            throw new AflnetException("Save params error!");
        }
        /*拼接指令*/
        TestControlTools.setIsRunning(true);
        String cmd = cmdTools.parse(cmdStartParams);
        Date date = new Date();
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd-hh-mm-ss-");
        String outputFileName = df.format(date) + cmdStartParams.getProtopcol() + "-output";
        String finalCmd = CmdConstent.RUN_AFLNET_BEFORE + outputFileName + CmdConstent.RUN_AFLNET_AFTER + cmd + aflnetProperties.getAflnetPath() + "live555/testProgs/" + "testOnDemandRTSPServer 8554";
        SystemRunningParams.aflnetData.put("aflnetName", outputFileName);
        log.info("The cmd is [{}]", finalCmd);
        /*执行指令*/
        System.out.println("testStart");
        cmdTools.runProgramCmd(finalCmd, outputFileName + ".zip");
    }

    @Override
    @NeedCutBefore(name = "aflnet", function = "stopBackup")//停止时完成数据入库
    public void testStop() {
        TestControlTools.setIsRunning(false);//指令终止 todo 后期需要考虑，发送终止指令停止测试
        SystemRunningParams.testTimeMessage.get("aflnet").put("end", System.currentTimeMillis());//指令停止时间
        log.info("Aflnet has been stopped ! ");
    }

    @Override
    public LinkedHashMap<String,String> getProcessInfo() {
        return SystemRunningParams.TestProgressMap;
    }
}
