package com.example.fuzzControll.service.impl;

import com.alibaba.fastjson2.JSON;
import com.example.fuzzControll.annotion.NeedCutAround;
import com.example.fuzzControll.annotion.NeedCutBefore;
import com.example.fuzzControll.conf.KittyProperties;
import com.example.fuzzControll.domain.bo.FuzzParams;
import com.example.fuzzControll.exception.testException.AflnetException;
import com.example.fuzzControll.exception.testException.CmdException;
import com.example.fuzzControll.exception.testException.FuzzException;
import com.example.fuzzControll.domain.bo.TestEntity;
import com.example.fuzzControll.service.FuzzParamsService;
import com.example.fuzzControll.service.VulnerabilityTypeService;
import com.example.fuzzControll.tools.system.GlobalClass;
import com.example.fuzzControll.tools.test.TestCmdTools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Slf4j
@Service("vulnerabilityTypeService")
public class VulnerabilityTypeServiceImpl implements VulnerabilityTypeService {
    TestCmdTools cmdTools = new TestCmdTools();
    @Autowired
    KittyProperties kitty;
    @Autowired
    FuzzParamsService fuzzParamsService;
    @Override
    @NeedCutAround(name ="kitty",function = "generation")
    public Map<String, List<String>> generation(TestEntity testEntity) throws FuzzException, CmdException {
        /*存入参数*/
        int missionId = GlobalClass.missionInfoMapper.selectTopMissionId();
        boolean flag = fuzzParamsService.saveFuzzParams(new FuzzParams(JSON.toJSONString(testEntity.getParamJson()), new Date(), missionId));
        if (!flag) {
            throw new AflnetException("Save params error!");
        }
        String cmd = parseParameters(testEntity);
        if (cmd.isEmpty()) {
            throw new FuzzException("cmd is null ! The number of parameters does not match!");
        }
        return cmdTools.runProgramCmdAndResult(cmd,"vulnerability","Vulnerability-"+testEntity.getTestClassName());
    }

    public String parseParameters(TestEntity testEntity) {
        try {
            switch (testEntity.getTestClassName().toLowerCase()) {
                case "array_index_out_of_bounds_vulnerability"://have error
                    return cmd(testEntity, 0);
                case "boundary_condition_vulnerability"://have error
                    return cmd(testEntity, 1);
                case "buffer_overflow_vulnerability"://have error
                    return cmd(testEntity, 2);
                case "command_injection_vulnerability"://have error
                    return cmd(testEntity, 3);
                case "memory_duplicate_release_vulnerability"://have error
                    return cmd(testEntity, 4);
                case "format_string_vulnerability"://have error
                    return cmd(testEntity, 5);
                case "integer_overflow_vulnerability"://have error
                    return cmd(testEntity, 6);
                case "numeric_error_vulnerability"://have error
                    return cmd(testEntity, 7);
                case "symbol_extension_vulnerability"://have error
                    return cmd(testEntity, 8);
                case "uaf_vulnerability"://have error
                    return cmd(testEntity, 9);
                case "cross_script_vulnerability"://have error
                    return cmd(testEntity, 10);
                case "sql_injection_vulnerability"://have error
                    return cmd(testEntity, 11);
                default:
                    throw new FuzzException("Unknown method!");
            }
        } catch (FuzzException e) {
            throw new FuzzException("Unknown class!");
        }
    }

    private String cmd(TestEntity testEntity, int kindNum) {
        return kitty.getVenvPath() + " " + kitty.getVulnerabilityTypePath() + "vul_types_test.py " + kindNum;
    }
}
